Index: django/db/backends/oracle/introspection.py
===================================================================
--- django/db/backends/oracle/introspection.py	(revision 17914)
+++ django/db/backends/oracle/introspection.py	(working copy)
@@ -1,3 +1,4 @@
+from django.db import QName
 from django.db.backends import BaseDatabaseIntrospection
 import cx_Oracle
 import re
@@ -37,56 +38,85 @@
             return super(DatabaseIntrospection, self).get_field_type(
                 data_type, description)
 
-    def get_table_list(self, cursor):
-        "Returns a list of table names in the current database."
-        cursor.execute("SELECT TABLE_NAME FROM USER_TABLES")
-        return [row[0].lower() for row in cursor.fetchall()]
+    def get_visible_tables_list(self, cursor):
+        "Returns a list of visible tables"
+        return self.get_qualified_tables_list(cursor, [self.connection.settings_dict['USER']])
 
-    def get_table_description(self, cursor, table_name):
+    def get_qualified_tables_list(self, cursor, schemas):
+        "Returns a list of table names in the given schemas list."
+        default_schema = self.connection.convert_schema(None)
+        if default_schema:
+            schemas.append(default_schema)
+        if not schemas:
+            return []
+        param_list = ', '.join(['%s']*len(schemas))
+        schemas = [s.upper() for s in schemas]
+        cursor.execute("""
+            SELECT OWNER, TABLE_NAME
+              FROM ALL_TABLES WHERE OWNER in (%s)""" % param_list, schemas)
+        return [QName(row[0].lower(), row[1].lower(), True)
+                for row in cursor.fetchall()]
+
+    def get_table_description(self, cursor, qname):
         "Returns a description of the table, with the DB-API cursor.description interface."
-        cursor.execute("SELECT * FROM %s WHERE ROWNUM < 2" % self.connection.ops.quote_name(table_name))
+        cursor.execute("SELECT * FROM %s WHERE ROWNUM < 2"
+                       % self.connection.ops.qualified_name(qname))
         description = []
         for desc in cursor.description:
             description.append((desc[0].lower(),) + desc[1:])
         return description
 
-    def table_name_converter(self, name):
-        "Table name comparison is case insensitive under Oracle"
+    def identifier_converter(self, name):
         return name.lower()
 
-    def _name_to_index(self, cursor, table_name):
+    def qname_converter(self, qname, force_schema=False):
+        assert isinstance(qname, QName)
+        if qname.db_format and (qname.schema or not force_schema):
+            return qname
+        schema = self.connection.convert_schema(qname.schema)
+        if not schema and force_schema:
+            schema = self.connection.settings_dict['USER']
+        return QName(schema, qname.table, True)
+
+    def _name_to_index(self, cursor, qname):
         """
         Returns a dictionary of {field_name: field_index} for the given table.
         Indexes are 0-based.
         """
-        return dict([(d[0], i) for i, d in enumerate(self.get_table_description(cursor, table_name))])
+        return dict([(d[0], i) for i, d in enumerate(self.get_table_description(cursor, qname))])
 
-    def get_relations(self, cursor, table_name):
+    def get_relations(self, cursor, qname):
         """
         Returns a dictionary of {field_index: (field_index_other_table, other_table)}
         representing all relationships to the given table. Indexes are 0-based.
         """
-        table_name = table_name.upper()
+        qname = self.qname_converter(qname, force_schema=True)
+        schema, table = qname.schema.upper(), qname.table.upper()
         cursor.execute("""
-    SELECT ta.column_id - 1, tb.table_name, tb.column_id - 1
-    FROM   user_constraints, USER_CONS_COLUMNS ca, USER_CONS_COLUMNS cb,
-           user_tab_cols ta, user_tab_cols tb
-    WHERE  user_constraints.table_name = %s AND
+    SELECT ta.column_id - 1, tb.table_name, tb.owner, tb.column_id - 1
+    FROM   all_constraints, ALL_CONS_COLUMNS ca, ALL_CONS_COLUMNS cb,
+           all_tab_cols ta, all_tab_cols tb
+    WHERE  all_constraints.table_name = %s AND
+           all_constraints.owner = %s AND
            ta.table_name = %s AND
+           ta.owner = %s AND
            ta.column_name = ca.column_name AND
            ca.table_name = %s AND
-           user_constraints.constraint_name = ca.constraint_name AND
-           user_constraints.r_constraint_name = cb.constraint_name AND
+           ca.owner = %s AND
+           all_constraints.constraint_name = ca.constraint_name AND
+           all_constraints.r_constraint_name = cb.constraint_name AND
            cb.table_name = tb.table_name AND
            cb.column_name = tb.column_name AND
-           ca.position = cb.position""", [table_name, table_name, table_name])
+           ca.position = cb.position""", [table, schema, table, schema,
+                                          table, schema])
 
         relations = {}
         for row in cursor.fetchall():
-            relations[row[0]] = (row[2], row[1].lower())
+            relations[row[0]] = (
+                row[3], QName(row[2].lower(), row[1].lower(), True))
         return relations
 
-    def get_indexes(self, cursor, table_name):
+    def get_indexes(self, cursor, qname):
         """
         Returns a dictionary of fieldname -> infodict for the given table,
         where each infodict is in the format:
@@ -96,27 +126,45 @@
         # This query retrieves each index on the given table, including the
         # first associated field name
         # "We were in the nick of time; you were in great peril!"
+        qname = self.qname_converter(qname, force_schema=True)
+        schema, table = qname.schema.upper(), qname.table.upper()
+        # There can be multiple constraints for a given column, and we 
+        # are interested if _any_ of them is unique or primary key, hence
+        # the group by + max.
         sql = """\
-SELECT LOWER(all_tab_cols.column_name) AS column_name,
-       CASE user_constraints.constraint_type
-           WHEN 'P' THEN 1 ELSE 0
-       END AS is_primary_key,
-       CASE user_indexes.uniqueness
-           WHEN 'UNIQUE' THEN 1 ELSE 0
-       END AS is_unique
-FROM   all_tab_cols, user_cons_columns, user_constraints, user_ind_columns, user_indexes
-WHERE  all_tab_cols.column_name = user_cons_columns.column_name (+)
-  AND  all_tab_cols.table_name = user_cons_columns.table_name (+)
-  AND  user_cons_columns.constraint_name = user_constraints.constraint_name (+)
-  AND  user_constraints.constraint_type (+) = 'P'
-  AND  user_ind_columns.column_name (+) = all_tab_cols.column_name
-  AND  user_ind_columns.table_name (+) = all_tab_cols.table_name
-  AND  user_indexes.uniqueness (+) = 'UNIQUE'
-  AND  user_indexes.index_name (+) = user_ind_columns.index_name
-  AND  all_tab_cols.table_name = UPPER(%s)
+SELECT column_name, max(is_primary_key), max(is_unique)
+  FROM (
+    SELECT LOWER(all_tab_cols.column_name) AS column_name,
+           CASE all_constraints.constraint_type
+               WHEN 'P' THEN 1 ELSE 0
+           END AS is_primary_key,
+           CASE all_indexes.uniqueness
+               WHEN 'UNIQUE' THEN 1 ELSE 0
+           END AS is_unique
+    FROM   all_tab_cols, all_cons_columns, all_constraints, all_ind_columns, all_indexes
+    WHERE  all_tab_cols.column_name = all_cons_columns.column_name (+)
+      AND  all_tab_cols.table_name = all_cons_columns.table_name (+)
+      AND  all_tab_cols.owner = all_cons_columns.owner (+)
+      AND  all_cons_columns.constraint_name = all_constraints.constraint_name (+)
+      AND  all_cons_columns.owner = all_constraints.owner (+)
+      AND  all_constraints.constraint_type (+) = 'P'
+      AND  all_ind_columns.column_name (+) = all_tab_cols.column_name
+      AND  all_ind_columns.table_name (+) = all_tab_cols.table_name
+      AND  all_ind_columns.index_owner (+) = all_tab_cols.owner
+      AND  all_indexes.uniqueness (+) = 'UNIQUE'
+      AND  all_indexes.index_name (+) = all_ind_columns.index_name
+      AND  all_indexes.table_owner (+) = all_ind_columns.index_owner
+      AND  all_tab_cols.table_name = %s
+      AND  all_tab_cols.owner = %s
+    )
+GROUP BY column_name
 """
-        cursor.execute(sql, [table_name])
+        cursor.execute(sql, [table, schema])
         indexes = {}
         for row in cursor.fetchall():
             indexes[row[0]] = {'primary_key': row[1], 'unique': row[2]}
         return indexes
+
+    def get_schema_list(self, cursor):
+        cursor.execute("SELECT USERNAME FROM ALL_USERS")
+        return [r[0] for r in cursor.fetchall()]
Index: django/db/backends/oracle/creation.py
===================================================================
--- django/db/backends/oracle/creation.py	(revision 17914)
+++ django/db/backends/oracle/creation.py	(working copy)
@@ -1,6 +1,8 @@
 import sys
 import time
+from django.db import QName
 from django.db.backends.creation import BaseDatabaseCreation
+from django.core.management.color import no_style
 
 TEST_DATABASE_PREFIX = 'test_'
 PASSWORD = 'Im_a_lumberjack'
@@ -43,14 +45,13 @@
     def __init__(self, connection):
         super(DatabaseCreation, self).__init__(connection)
 
-    def _create_test_db(self, verbosity=1, autoclobber=False):
+    def _get_ddl_parameters(self):
         TEST_NAME = self._test_database_name()
         TEST_USER = self._test_database_user()
         TEST_PASSWD = self._test_database_passwd()
         TEST_TBLSPACE = self._test_database_tblspace()
         TEST_TBLSPACE_TMP = self._test_database_tblspace_tmp()
-
-        parameters = {
+        return {
             'dbname': TEST_NAME,
             'user': TEST_USER,
             'password': TEST_PASSWD,
@@ -58,6 +59,8 @@
             'tblspace_temp': TEST_TBLSPACE_TMP,
         }
 
+    def _create_test_db(self, verbosity=1, autoclobber=False, schemas=[]):
+        parameters = self._get_ddl_parameters()
         cursor = self.connection.cursor()
         if self._test_database_create():
             try:
@@ -65,7 +68,9 @@
             except Exception, e:
                 sys.stderr.write("Got an error creating the test database: %s\n" % e)
                 if not autoclobber:
-                    confirm = raw_input("It appears the test database, %s, already exists. Type 'yes' to delete it, or 'no' to cancel: " % TEST_NAME)
+                    confirm = raw_input("It appears the test database, %(dbname)s, already "
+                                        "exists. Type 'yes' to delete it, or 'no' to cancel: "
+                                        % parameters)
                 if autoclobber or confirm == 'yes':
                     try:
                         if verbosity >= 1:
@@ -83,11 +88,13 @@
             if verbosity >= 1:
                 print "Creating test user..."
             try:
-                self._create_test_user(cursor, parameters, verbosity)
+                self._create_test_user(cursor, parameters, verbosity, dba=bool(schemas))
             except Exception, e:
                 sys.stderr.write("Got an error creating the test user: %s\n" % e)
                 if not autoclobber:
-                    confirm = raw_input("It appears the test user, %s, already exists. Type 'yes' to delete it, or 'no' to cancel: " % TEST_USER)
+                    confirm = raw_input("It appears the test user, %(user)s, already exists. "
+                                        "Type 'yes' to delete it, or 'no' to cancel: "
+                                        % parameters)
                 if autoclobber or confirm == 'yes':
                     try:
                         if verbosity >= 1:
@@ -95,7 +102,7 @@
                         self._destroy_test_user(cursor, parameters, verbosity)
                         if verbosity >= 1:
                             print "Creating test user..."
-                        self._create_test_user(cursor, parameters, verbosity)
+                        self._create_test_user(cursor, parameters, verbosity, dba=bool(schemas))
                     except Exception, e:
                         sys.stderr.write("Got an error recreating the test user: %s\n" % e)
                         sys.exit(2)
@@ -105,8 +112,8 @@
 
         self.connection.settings_dict['SAVED_USER'] = self.connection.settings_dict['USER']
         self.connection.settings_dict['SAVED_PASSWORD'] = self.connection.settings_dict['PASSWORD']
-        self.connection.settings_dict['TEST_USER'] = self.connection.settings_dict['USER'] = TEST_USER
-        self.connection.settings_dict['PASSWORD'] = TEST_PASSWD
+        self.connection.settings_dict['TEST_USER'] = self.connection.settings_dict['USER'] = parameters['user']
+        self.connection.settings_dict['PASSWORD'] = parameters['password']
 
         return self.connection.settings_dict['NAME']
 
@@ -115,33 +122,21 @@
         Destroy a test database, prompting the user for confirmation if the
         database already exists. Returns the name of the test database created.
         """
-        TEST_NAME = self._test_database_name()
-        TEST_USER = self._test_database_user()
-        TEST_PASSWD = self._test_database_passwd()
-        TEST_TBLSPACE = self._test_database_tblspace()
-        TEST_TBLSPACE_TMP = self._test_database_tblspace_tmp()
+        parameters = self._get_ddl_parameters()
 
         self.connection.settings_dict['USER'] = self.connection.settings_dict['SAVED_USER']
         self.connection.settings_dict['PASSWORD'] = self.connection.settings_dict['SAVED_PASSWORD']
 
-        parameters = {
-            'dbname': TEST_NAME,
-            'user': TEST_USER,
-            'password': TEST_PASSWD,
-            'tblspace': TEST_TBLSPACE,
-            'tblspace_temp': TEST_TBLSPACE_TMP,
-        }
-
         cursor = self.connection.cursor()
         time.sleep(1) # To avoid "database is being accessed by other users" errors.
+        if self._test_database_create():
+            if verbosity >= 1:
+                print 'Destroying test database tables...'
+            self._execute_test_db_destruction(cursor, parameters, verbosity)
         if self._test_user_create():
             if verbosity >= 1:
                 print 'Destroying test user...'
             self._destroy_test_user(cursor, parameters, verbosity)
-        if self._test_database_create():
-            if verbosity >= 1:
-                print 'Destroying test database tables...'
-            self._execute_test_db_destruction(cursor, parameters, verbosity)
         self.connection.close()
 
     def _execute_test_db_creation(self, cursor, parameters, verbosity):
@@ -159,16 +154,19 @@
         ]
         self._execute_statements(cursor, statements, parameters, verbosity)
 
-    def _create_test_user(self, cursor, parameters, verbosity):
+    def _create_test_user(self, cursor, parameters, verbosity, dba=False):
         if verbosity >= 2:
             print "_create_test_user(): username = %s" % parameters['user']
+        parameters = parameters.copy()
+        parameters['dba'] = ', DBA' if dba else ''
+
         statements = [
             """CREATE USER %(user)s
                IDENTIFIED BY %(password)s
                DEFAULT TABLESPACE %(tblspace)s
                TEMPORARY TABLESPACE %(tblspace_temp)s
             """,
-            """GRANT CONNECT, RESOURCE TO %(user)s""",
+            """GRANT CONNECT, RESOURCE %(dba)s TO %(user)s""",
         ]
         self._execute_statements(cursor, statements, parameters, verbosity)
 
@@ -186,10 +184,14 @@
             print "_destroy_test_user(): user=%s" % parameters['user']
             print "Be patient.  This can take some time..."
         statements = [
-            'DROP USER %(user)s CASCADE',
+            self.sql_destroy_schema(parameters['user'], style=None)
         ]
         self._execute_statements(cursor, statements, parameters, verbosity)
 
+    def sql_destroy_schema(self, schema, style):
+        return "DROP USER %s CASCADE" % schema
+
+
     def _execute_statements(self, cursor, statements, parameters, verbosity):
         for template in statements:
             stmt = template % parameters
@@ -272,3 +274,175 @@
 
     def set_autocommit(self):
         self.connection.connection.autocommit = True
+
+    def _create_test_schemas(self, verbosity, schemas, autoclobber):
+        if not self._test_user_create():
+            return []
+        cursor = self.connection.cursor()
+        parameters = self._get_ddl_parameters()
+        parameters['authorization'] = parameters['user']
+        conv = self.connection.introspection.identifier_converter
+        existing_schemas = [conv(s) for s in self.connection.introspection.get_schema_list(cursor)]
+        conflicts = [conv(s) for s in existing_schemas if conv(s) in schemas]
+        if conflicts:
+            print 'The following users already exists: %s' % ', '.join(conflicts) 
+            if not autoclobber:
+                confirm = raw_input(
+                    "Type 'yes' if you would like to try deleting these users "
+                    "or 'no' to cancel: ")
+            if autoclobber or confirm == 'yes':
+                for schema in conflicts:
+                    parameters['user'] = schema
+                    if verbosity >= 1:
+                        print "Destroying user %s" % schema
+                    self._destroy_test_user(cursor, parameters, verbosity)
+                    existing_schemas.remove(schema)
+            else:
+                print "Tests cancelled."
+                sys.exit(1)
+           
+        to_create = [s for s in schemas if s not in existing_schemas]
+        for schema in to_create:
+            parameters['user'] = schema
+            if verbosity >= 1:
+                print "Creating user %s" % schema
+            self._create_test_user(cursor, parameters, verbosity)
+        return to_create
+
+    def needs_separate_conn(self, from_qname, to_qname):
+        conv = self.connection.introspection.qname_converter
+        def_schema = conv(QName(None, None, False), force_schema=True).schema
+        from_qname = conv(from_qname, force_schema=True)
+        to_qname = conv(to_qname, force_schema=True)
+        return (def_schema != from_qname.schema
+                or to_qname.schema != from_qname.schema)
+
+    def sql_for_inline_foreign_key_references(self, field, known_models, style):
+        """
+        Return the SQL snippet defining the foreign key reference for a field.
+
+        Oracle doesn't let you do cross-schema foreign keys, except if you
+        are connected to the "from" schema. Don't ask why.
+        """
+        if self.needs_separate_conn(field.model._meta.qualified_name,
+                                    field.rel.to._meta.qualified_name):
+            return [], True
+        return super(DatabaseCreation, self).sql_for_inline_foreign_key_references(field, known_models, style)
+
+    def sql_for_pending_references(self, model, style, pending_references,
+                                   second_pass=False):
+        """
+        Sad fact of life: On Oracle it is impossible to do cross-schema
+        references unless you explisitly grant REFERENCES on the referenced
+        table, and in addition the reference is made from the schema
+        containing the altered table (the one getting the new constraint).
+        To make this even nicer, it is impossible to do the GRANT using the
+        same user we are giving the REFERENCES right, as you can't GRANT
+        yourself.
+
+        The solution we are using is to do the pending cross-schema references
+        in two stages after all tables have been created:
+            1) Connect as the foreign key's target table owner, and grant
+               REFERENCES to all users needing to do foreign keys.
+            2) Connect as the source table's owner, and create the foreign
+               keys.
+        To support this arrangement, we will create only non-cross-schema
+        references unless we are explicitly told by the second_pass flag
+        that it is safe to do the cross schema references.
+
+        It is possible to grant REFERENCES to public (but it seems other roles
+        will not work), but as we need to anyways do this multi-connection
+        dance it seems better to do the grants explicitly only when needed.
+        """
+        if second_pass:
+            return super(DatabaseCreation, self).sql_for_pending_references(
+                model, style, pending_references)
+        # Split the "safe" and "unsafe" references apart, and call
+        # the super() method for the safe set.
+        cross_schema_refs = []
+        single_schema_refs = []
+        if model in pending_references:
+            for rel_class, f in pending_references[model]:
+                if self.needs_separate_conn(rel_class._meta.qualified_name,
+                                            model._meta.qualified_name):
+                    cross_schema_refs.append((rel_class, f))
+                else:
+                    single_schema_refs.append((rel_class, f))
+        sql = []
+        if single_schema_refs:
+            pending_references[model] = single_schema_refs
+            sql = super(DatabaseCreation, self).sql_for_pending_references(
+                model, style, pending_references)
+        if cross_schema_refs:
+            pending_references[model] = cross_schema_refs
+        return sql
+
+    def post_create_pending_references(self, pending_references, as_sql=False):
+        # Build a dictionary: from_schema -> [(model, refs)...]
+        references_to_schema = {}
+        sql = []
+        conv = self.connection.introspection.qname_converter
+        for model, refs in pending_references.items():
+            schema = conv(model._meta.qualified_name, force_schema=True).schema
+            if schema not in references_to_schema:
+                references_to_schema[schema] = []
+            references_to_schema[schema].append((model, refs))
+        # Pass 1: give grants.
+        for schema, all_refs in references_to_schema.items():
+            grant_to = set()
+            for model, refs in all_refs:
+                for ref in refs:
+                    to_user = conv(ref[0]._meta.qualified_name,
+                                   force_schema=True).schema
+                    if to_user != schema:
+                        grant_to.add((model, to_user))
+            sql.extend(self._grant_references(schema, grant_to, as_sql))
+        # Prepare for pass 2. This time we must connect as the user
+        # of the altered table's schema. So, first build a dictionary of
+        # from_schema -> [{model: [refs]}], that is, build a
+        # pending_references for each schema separately.
+        references_from_schema = {}
+        for model, refs in pending_references.items():
+            for ref in refs:
+                schema = conv(ref[0]._meta.qualified_name,
+                              force_schema=True).schema
+                if schema not in references_from_schema:
+                    references_from_schema[schema] = {}
+                if model not in references_from_schema[schema]:
+                    references_from_schema[schema][model] = []
+                references_from_schema[schema][model].append(ref)
+        # Pass 2: create the actual references
+        for schema, ref_dict in references_from_schema.items():
+            per_schema_sql = ['-- Connect as user "%s"' % schema] if as_sql else []
+            for model, refs in ref_dict.items():
+                ref_sql = self.sql_for_pending_references(model, no_style(),
+                                                          ref_dict, second_pass=True)
+                per_schema_sql.extend(ref_sql)
+            if not as_sql:
+                self._run_sql_as_user(schema, per_schema_sql)
+            sql.extend(per_schema_sql)
+        return sql
+
+    def _grant_references(self, schema, grant_to, as_sql):
+        sql = ['-- Connect as user "%s"' % schema] if as_sql else []
+        qn = self.connection.ops.quote_name
+        for model, user in grant_to:
+            sql.append('GRANT REFERENCES ON %s TO %s'
+                       % (qn(model._meta.db_table), qn(user)))
+        if not as_sql:
+            self._run_sql_as_user(schema, sql)
+        return sql
+
+    def _run_sql_as_user(self, user, sql):
+        if not sql:
+            return
+        self.connection.close()
+        try:
+            old_settings = self.connection.settings_dict.copy()
+            self.connection.settings_dict['USER'] = user
+            cursor = self.connection.cursor()
+            for q in sql:
+                cursor.execute(q)
+        finally:
+            self.connection.close()
+            self.connection.settings_dict = old_settings
